using System;
using System.Drawing;
using System.Collections.Generic;

namespace Skyiv.Ben.PushBox.Common
{
  /// <summary>
  /// Ѱ·
  /// </summary>
  static class FindPath
  {
    static Size[] offsets = { new Size(0, 1), new Size(1, 0), new Size(0, -1), new Size(-1, 0) };
    static Direction[] directions = { Direction.South, Direction.East, Direction.North, Direction.West };

    /// <summary>
    /// Ѱ·
    /// </summary>
    /// <param name="map">ͼ</param>
    /// <param name="from"></param>
    /// <param name="to">Ŀĵ</param>
    /// <returns>·</returns>
    public static Queue<Direction> Seek(byte[,] map, Point from, Point to)
    {
      Queue<Direction> moveQueue = new Queue<Direction>(); // ·
      int value; // Ŀĵؾصһ,仯: ... => 2 => 1 => 3 => 2 => 1 => 3 => 2 => 1
      if (Seek(map, to, out value)) // ҵһ·
      {
        Point here = from; // (˵λ)
        Point nbr = new Point(); // ܵھ
        for (value = (value + 1) % 3 + 1; here != to; value = (value + 1) % 3 + 1) // Ŀĵ
        {
          for (int i = 0; i < offsets.Length; i++)
          {
            nbr = Fcl.Add(here, offsets[i]); // ʼѰܵھ
            if (Block.Value(map[nbr.Y, nbr.X]) == value) // 
            {
              moveQueue.Enqueue(directions[i]); // ·Ŀĵһ
              break;
            }
          }
          here = nbr; // ǰ
        }
      }
      Block.CleanAllMark(map); // б־,ֳָ
      return moveQueue; // Ѱҵ·,޷ĿĵΪ·ߵĳΪ
    }

    /// <summary>
    /// Ѱ·,ʹù
    /// </summary>
    /// <param name="map">ͼ</param>
    /// <param name="to">Ŀĵ</param>
    /// <param name="value">:ʱǵֵ</param>
    /// <returns>Ƿɹ</returns>
    static bool Seek(byte[,] map, Point to, out int value)
    {
      Queue<Point> q = new Queue<Point>();
      Block.Mark(ref map[to.Y, to.X], 1); // ĿĵؿʼѰҳ,ĿĵرΪ1
      Point nbr = Point.Empty; // ܵھ
      for (; ; )
      {
        value = Block.Value(map[to.Y, to.X]) % 3 + 1; // Ŀĵؾصһ,,仯:
        for (int i = 0; i < offsets.Length; i++)      // 1 => 2 => 3 => 1 => 2 => 3 => 1 => 2 => 3 => ...
        {
          nbr = Fcl.Add(to, offsets[i]); // ʼѰܵھ
          if (Block.IsMan(map[nbr.Y, nbr.X])) break; // (˵λ)
          if (Block.IsBlank(map[nbr.Y, nbr.X])) // ߵ·
          {
            Block.Mark(ref map[nbr.Y, nbr.X], value); // ,ֹԺ·
            q.Enqueue(nbr); // ,ȴԺѰ
          }
        }
        if (Block.IsMan(map[nbr.Y, nbr.X])) break; // 
        if (q.Count == 0) return false; // ޷
        to = q.Dequeue(); // ,Ѱ,ǹ,ΪǰѾܹߵ·ȫ.
      }
      return true; // ҵһ·
    }
  }
}
