using System;
using System.Drawing;
using System.Text;
using System.IO;
using System.Reflection;

namespace Skyiv.Ben.PushBox.Common
{
  /// <summary>
  /// ֶκͷ
  /// </summary>
  static class Pub
  {
    public const int OverY = 4; // Ļ(Y)򳬹
    public const int DefaultMaxLevelSize = 32; // ȱʡسߴ(Ⱥ͸߶)
    public const int DefaultStepDelay = 100;   // ȱʡƶʱ()
    public const int DefaultReplayDelay = 300; // ȱʡطʱ()
    public const int MaxDelay = 1000;          // ʱ()
    public readonly static string ConfigFileName = Path.Combine(baseDirectory, "PushBox.cfg"); // ļȫ·
    public readonly static Encoding Encode = Encoding.GetEncoding("GB2312"); // Windows Mobile 6.0 ֧ GB18030
    static string baseDirectory { get { return Path.GetDirectoryName(Pub.CodeBases); } } // ڵĿ¼

    static Assembly Assembly { get { return Assembly.GetExecutingAssembly(); } }
    static AssemblyName AssemblyName { get { return Pub.Assembly.GetName(); } }
    public static Version Version { get { return Pub.AssemblyName.Version; } } // İ汾
    public static string TextDirectory { get { return Path.Combine(baseDirectory, "text"); } }
    public static string DataDirectory { get { return Path.Combine(baseDirectory, "data"); } }
    public static string StepsDirectory { get { return Path.Combine(baseDirectory, "steps"); } }
    public const string TextExtName = ".bxa"; // ıļչ
    public const string DataExtName = ".bxb"; // ļչ
    public const string StepsExtName = ".bxs"; // ͨزļչ

    /// <summary>
    /// ȫ·
    /// </summary>
    public static string CodeBases
    {
      get
      {
        string codeBase = Pub.AssemblyName.CodeBase;
        string uri = "file:///";
        if (codeBase.StartsWith(uri)) codeBase = codeBase.Substring(uri.Length);
        return codeBase;
      }
    }

    /// <summary>
    /// ָߴʾַʽΪ: x
    /// </summary>
    /// <param name="size">ָĳߴ</param>
    /// <returns>ָߴʾַ</returns>
    public static string ToString(Size size)
    {
      return size.Width + "x" + size.Height;
    }

    /// <summary>
    /// ߷תΪַ
    /// </summary>
    /// <param name="steps">߷</param>
    /// <returns>תַ</returns>
    public static string ToString(Step[] steps)
    {
      StringBuilder sb = new StringBuilder();
      foreach (Step step in steps) sb.Append((char)step);
      char[] array = sb.ToString().ToCharArray();
      Array.Reverse(array);
      return new string(array);
    }

    /// <summary>
    /// ָ汾ϢʽΪ: x.x (build: yyyy-MM-dd)
    /// </summary>
    /// <param name="version">ָİ汾</param>
    /// <returns>ָ汾Ϣ</returns>
    public static string GetVersionBuildString(Version version)
    {
      double days = version.Build + 2 * version.Revision / ((double)TimeSpan.TicksPerDay / TimeSpan.TicksPerSecond);
      return string.Format("{0} (Build: {1})", version.ToString(2), (new DateTime(2000, 1, 1)).AddDays(days).ToString("yyyy-MM-dd HH:mm:ss"));
    }

    /// <summary>
    /// ָ쳣Ϣں쳣Ϣ
    /// </summary>
    /// <param name="ex">ָ쳣</param>
    /// <param name="isDebug">ǷϸϢ</param>
    /// <returns>ָ쳣Ϣ</returns>
    public static string GetMessage(Exception ex, bool isDebug)
    {
      StringBuilder sb = new StringBuilder();
      for (Exception e = ex; e != null; e = e.InnerException)
      {
        sb.Append(isDebug ? e.ToString() : e.Message);
        sb.Append(Fcl.NewLine);
      }
      return sb.ToString();
    }
  }
}
