using System;
using System.Drawing;
using System.Threading;
using System.Collections.Generic;
using System.Windows.Forms;
using Skyiv.Ben.PushBox.Common;

namespace Skyiv.Ben.PushBox.Window
{
  partial class MainForm
  {
    /// <summary>
    /// װ뵱ǰ
    /// </summary>
    /// <param name="isReSizeClient">Ƿݵǰسߴıͻߴ</param>
    void LoadLevel(bool isReSizeClient)
    {
      env.LoadLevel();
      if (isReSizeClient && Environment.OSVersion.Platform != PlatformID.WinCE)
        ClientSize = env.GetClientSize(sbrMain.Visible ? sbrMain.Height : 0);
      ClientSizeChanged();
      UpdateStatus();
    }

    /// <summary>
    /// ͻߴıʱҪȡĶ
    /// </summary>
    void ClientSizeChanged()
    {
      env.ClientSize = new Size(ClientSize.Width, ClientSize.Height +
        Pub.OverY - (sbrMain.Visible ? sbrMain.Height : 0));
      env.SetBoxInfo();
      Invalidate();
    }

    /// <summary>
    /// ָϴ˳ʱ߷
    /// </summary>
    /// <param name="steps">߷</param>
    void Restore(string steps)
    {
      Rectangle invalid;
      foreach (char c in steps)
      {
        Step step = c;
        if (!env.StepIt(step.Direct, step.IsStop, out invalid)) break;
      }
      Invalidate();
      UpdateStatus();
    }

    /// <summary>
    /// ָǰһ()
    /// </summary>
    /// <param name="dir">ǰķ</param>
    /// <param name="isStop">ʱǷͣ</param>
    void StepIt(Direction dir, bool isStop)
    {
      Rectangle invalid;
      if (!env.StepIt(dir, isStop, out invalid)) return;
      Invalidate(invalid);
      UpdateStatus();
    }

    /// <summary>
    /// ˺һ(һ)
    /// </summary>
    /// <returns>Ƿɡ</returns>
    bool Back()
    {
      Rectangle invalid;
      bool isStop = env.Back(out invalid);
      Invalidate(invalid);
      UpdateStatus();
      return isStop;
    }

    /// <summary>
    /// Խƶλ
    /// </summary>
    /// <returns>Ƿɹ</returns>
    bool TryMove()
    {
      Queue<Direction> moveQueue = env.GetMoveInfo();
      if (moveQueue == null) return false;
      if (moveQueue.Count <= 0) return false;
      int count = moveQueue.Count;
      while (moveQueue.Count > 0)
      {
        bool isStop = (count == moveQueue.Count);
        if (!isStop && env.StepDelay > 0) Thread.Sleep(env.StepDelay);
        StepIt(moveQueue.Dequeue(), isStop);
      }
      return true;
    }

    /// <summary>
    /// Խƶλ
    /// </summary>
    /// <returns>Ƿɹ</returns>
    bool TryPush()
    {
      Direction dir;
      int steps = env.GetPushInfo(out dir);
      if (steps <= 0) return false;
      for (int i = 0; i < steps; i++)
      {
        bool isStop = (i == 0);
        if (!isStop && env.StepDelay > 0) Thread.Sleep(env.StepDelay);
        StepIt(dir, isStop);
      }
      return true;
    }

    /// <summary>
    /// ״̬ϢͲ˵
    /// </summary>
    void UpdateStatus()
    {
      sbrMain.Text = env.StatusMessage;
      miExit.Enabled = !env.IsReplay && !env.IsDesign;
      miSystem.Enabled = !env.IsReplay;
      miOption.Enabled = !env.HasError && !env.IsReplay;
      miSelectLevel.Enabled = !env.IsDesign && !env.HasError && !env.IsReplay && (!env.CanUndo || env.IsFinish);
      miSelectGroup.Enabled = !env.IsDesign && miSelectLevel.Enabled && env.Groups.Length > 1;
      miLastLevel.Enabled = miNextLevel.Enabled = miSelectLevel.Enabled && env.Level < env.MaxLevel - 1;
      miFirstLevel.Enabled = miPrevLevel.Enabled = miSelectLevel.Enabled && env.Level > 0;
      miLastGroup.Enabled = miNextGroup.Enabled = miSelectGroup.Enabled && env.Group < env.Groups.Length - 1;
      miFirstGroup.Enabled = miPrevGroup.Enabled = miSelectGroup.Enabled && env.Group > 0;
      miConfig.Enabled = miTran.Enabled = !env.IsDesign && !env.IsReplay && (!env.CanUndo || env.IsFinish);
      miDesign.Enabled = miSelectLevel.Enabled && !env.CanUndo;
      miRestartOrStopOrSave.Enabled = !env.HasError && (env.IsDesign ? (!env.IsReplay && env.HasWorker) : (env.IsReplay || env.CanUndo));
      miUndoOrCancel.Enabled = miBackOrManOrBox.Enabled = !env.HasError && !env.IsReplay && (env.IsDesign || env.CanUndo);
      miPrevLevel2OrSlot.Enabled = !env.HasError && !env.IsReplay && (env.IsDesign || (miSelectLevel.Enabled && env.Level > 0));
      miNextLevel2OrWall.Enabled = !env.HasError && !env.IsReplay && (env.IsDesign || (miSelectLevel.Enabled && env.Level < env.MaxLevel - 1));
      miRecordOrBrick.Enabled = !env.HasError && !env.IsReplay && (env.IsDesign || env.IsFinish);
      miReplayOrLand.Enabled = !env.HasError && !env.IsReplay && (env.IsDesign || env.CanReplay);
      miRestartOrStopOrSave.Text = !env.IsDesign ? (!env.IsReplay ? "" : "") : "";
      miUndoOrCancel.Text = !env.IsDesign ? "I" : "";
      miBackOrManOrBox.Text = !env.IsDesign ? "" : env.HasWorker ? "" : "";
      miPrevLevel2OrSlot.Text = !env.IsDesign ? "" : "";
      miNextLevel2OrWall.Text = !env.IsDesign ? "" : "ǽ";
      miRecordOrBrick.Text = !env.IsDesign ? "" : "ש";
      miReplayOrLand.Text = !env.IsDesign ? "ط" : "";
      Update();
    }
  }
}
