using System;
using System.Drawing;
using System.Threading;
using Skyiv.Ben.PushBox.Common;

namespace Skyiv.Ben.PushBox.Window
{
  partial class MainForm
  {
    Rectangle workerThreadInvalidRectangle;
    bool workerThreadIsStop;

    private void miReplayOrLand_Click(object sender, EventArgs e)
    {
      if (env.IsDesign)
      {
        env.Pen = Block.Land;
        UpdateStatus();
      }
      else
      {
        env.IsReplay = true;
        workerThreadIsStop = false;
        UpdateStatus();
        ThreadPool.QueueUserWorkItem(WorkerThreadReplay, env.GetSteps());
      }
    }

    /// <summary>
    /// طͨز,ʹų́߳
    /// </summary>
    /// <param name="steps">ͨز</param>
    private void WorkerThreadReplay(object steps)
    {
      try
      {
        foreach (char c in (string)steps)
        {
          if (workerThreadIsStop) break;
          if (env.ReplayDelay > 0) Thread.Sleep(env.ReplayDelay);
          Step step = c;
          if (!env.StepIt(step.Direct, step.IsStop, out workerThreadInvalidRectangle)) break;
          Invoke(new EventHandler(WorkerThreadUpdateStatus));
        }
      }
      finally
      {
        env.IsReplay = false;
        Invoke(new EventHandler(WorkerThreadUpdateStatus));
      }
    }

    /// <summary>
    /// ״̬
    /// </summary>
    /// <param name="sender">¼Դ</param>
    /// <param name="e">κ¼ݵ¼</param>
    void WorkerThreadUpdateStatus(object sender, EventArgs e)
    {
      Invalidate(workerThreadInvalidRectangle);
      UpdateStatus();
    }
  }
}

