using System;
using System.IO;
using System.Windows.Forms;
using Skyiv.Ben.PushBox.Common;

namespace Skyiv.Ben.PushBox.Window
{
  /// <summary>
  /// תԻ
  /// </summary>
  public partial class TranDlg : Form
  {
    bool isEdit; // Ƿڱ༭״̬
    int maxLevelSize;
    DataFile db;

    public string[] Groups { set { cbxGroup.DataSource = value; } }
    public int MaxLevelSize { set { maxLevelSize = value; } }

    public TranDlg(bool isTopMost)
    {
      InitializeComponent();
      TopMost = isTopMost;
    }

    protected override void OnLoad(EventArgs e)
    {
      base.OnLoad(e);
      db = new DataFile();
      if (cbxGroup.Items.Count <= 0)
      {
        btnEdit.Enabled = btnExportOrSave.Enabled = btnImportOrCancel.Enabled = cbxGroup.Enabled = false;
        tbxMsg.Text = "˵ ->  -> á";
      }
    }

    protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
    {
      if (isEdit)
      {
        MessageBox.Show("ڱ༭˳ȡ桱򡰷", "");
        e.Cancel = true;
      }
      else if (db != null) db.Dispose();
      base.OnClosing(e);
    }

    private void btnEdit_Click(object sender, EventArgs e)
    {
      tbxMsg.Text = Fcl.ReadAllText(Path.Combine(Pub.TextDirectory, cbxGroup.SelectedItem + Pub.TextExtName));
      cbxGroup.Enabled = false;
      tbxMsg.ReadOnly = false;
      isEdit = true;
      btnEdit.Enabled = false;
      btnExportOrSave.Text = "";
      btnImportOrCancel.Text = "";
    }

    private void btnExportOrSave_Click(object sender, EventArgs e)
    {
      SetEnable(false);
      try
      {
        if (isEdit) Save(true);
        else db.Export(cbxGroup.SelectedItem.ToString(), tbxMsg);
      }
      catch (Exception ex)
      {
        tbxMsg.Text += Pub.GetMessage(ex, false);
      }
      tbxMsg.Select(tbxMsg.Text.Length, 0);
      tbxMsg.ScrollToCaret();
      SetEnable(true);
    }

    private void btnImportOrCancel_Click(object sender, EventArgs e)
    {
      SetEnable(false);
      try
      {
        if (isEdit) Save(false);
        else db.Import(cbxGroup.SelectedItem.ToString(), maxLevelSize, tbxMsg);
      }
      catch (Exception ex)
      {
        tbxMsg.Text += Pub.GetMessage(ex, false);
      }
      tbxMsg.Select(tbxMsg.Text.Length, 0);
      tbxMsg.ScrollToCaret();
      SetEnable(true);
    }

    void SetEnable(bool isEnable)
    {
      btnEdit.Enabled = btnExportOrSave.Enabled = btnImportOrCancel.Enabled = cbxGroup.Enabled = isEnable;
      Update();
    }

    void Save(bool isSave)
    {
      if (isSave)
      {
        if (!Directory.Exists(Pub.TextDirectory)) Directory.CreateDirectory(Pub.TextDirectory);
        Fcl.WriteAllText(Path.Combine(Pub.TextDirectory, cbxGroup.SelectedItem + Pub.TextExtName), tbxMsg.Text);
      }
      tbxMsg.Text = isSave ? "ϷıļѾ" : "Ѿ༭";
      isEdit = false;
      btnEdit.Enabled = true;
      btnExportOrSave.Text = "";
      btnImportOrCancel.Text = "";
      cbxGroup.Enabled = true;
      tbxMsg.ReadOnly = true;
    }
  }
}