namespace Skyiv.Ben.PushBox.Common
{
  /// <summary>
  /// Ԫ:   ǽ ש  
  /// </summary>
  static class Block
  {
    public const byte Land = 0; // 
    public const byte Slot = 1; // 
    public const byte Wall = 2; // ǽ
    public const byte Brick = 3; // ש: ͬǽ,һǽΧ
    public const byte Box0 = 4; // ӷڵ
    public const byte Box1 = 5; // ӷڲ
    public const byte Man0 = 6; // վڵ
    public const byte Man1 = 7; // վڲ

    const string mask = "-+#%xX()"; // (*.bxa)ļ,δϸ

    public static char GetChar(byte block)
    {
      return mask[block & 0x07];
    }

    public static byte GetByte(char block)
    {
      return (byte)mask.IndexOf(block);
    }

    public static void CleanAllMark(byte[,] bb)
    {
      for (int i = 0; i < bb.GetLength(0); i++)
        for (int j = 0; j < bb.GetLength(1); j++)
          bb[i, j] &= 0x07;
    }

    public static void Mark(ref byte block, int value)
    {
      block |= (byte)(value << 3);
    }

    public static int Value(byte block)
    {
      return block >> 3;
    }

    public static string GetPenName(byte block)
    {
      return "زǽש"[block & 0x07].ToString();
    }

    public static void Update(ref byte block, byte pen)
    {
      if (IsSlot(block) && pen == Block.Man0) pen = Block.Man1;
      if (IsSlot(block) && pen == Block.Box0) pen = Block.Box1;
      block = pen;
    }

    public static void ManIn(ref byte block)
    {
      block += (Man0 - Land);
    }

    public static void ManOut(ref byte block)
    {
      block -= (Man0 - Land);
    }

    public static void BoxIn(ref byte block)
    {
      block += (Box0 - Land);
    }

    public static void BoxOut(ref byte block)
    {
      block -= (Box0 - Land);
    }

    public static bool IsBlock(byte block)
    {
      return block <= Man1;
    }

    public static bool IsSlot(byte block)
    {
      return block == Slot || block == Box1 || block == Man1;
    }

    public static bool IsBlank(byte block)
    {
      return block == Land || block == Slot;
    }

    public static bool IsBox(byte block)
    {
      return block == Box0 || block == Box1;
    }

    public static bool IsMan(byte block)
    {
      return block == Man0 || block == Man1;
    }
  }
}
