using System;
using System.Windows.Forms;
using Skyiv.Ben.PushBox.Common;

namespace Skyiv.Ben.PushBoxStd.Window
{
  public partial class OptionDlg : Form
  {
    bool isOk;

    public bool IsOk { get { return isOk; } }
    public bool IsSave { get { return chkSave.Checked; } set { chkSave.Checked = value; } }

    public int StepDelay
    {
      get { return GetDelay(tbxStepDelay.Text); }
      set { tbxStepDelay.Text = value.ToString(); }
    }

    public int ReplayDelay
    {
      get { return GetDelay(tbxReplayDelay.Text); }
      set { tbxReplayDelay.Text = value.ToString(); }
    }

    public OptionDlg(bool isTopMost)
    {
      InitializeComponent();
      TopMost = isTopMost;
    }

    private void miOk_Click(object sender, EventArgs e)
    {
      isOk = true;
      Close();
    }

    private void miCancel_Click(object sender, EventArgs e)
    {
      isOk = false;
      Close();
    }

    int GetDelay(string str)
    {
      int delay = 0;
      try
      {
        delay = int.Parse(str);
      }
      catch { }
      if (delay < 0) delay = 0;
      if (delay > Pub.MaxDelay) delay = Pub.MaxDelay;
      return delay;
    }
  }
}