using System;
using System.Windows.Forms;

namespace Skyiv.Ben.PushBoxStd.Window
{
  public partial class SelectLevelDlg : Form
  {
    bool isOk;
    int maxLevel;

    public bool IsOk { get { return isOk; } }
    public int MaxLevel { set { maxLevel = value; } }

    public int Level
    {
      get
      {
        int level = 1;
        try
        {
          level = int.Parse(tbxLevel.Text);
        }
        catch { }
        if (level < 1) level = 1;
        if (level > maxLevel) level = maxLevel;
        return level - 1;
      }
      set
      {
        tbxLevel.Text = (value + 1).ToString();
      }
    }

    public SelectLevelDlg(bool isTopMost)
    {
      InitializeComponent();
      TopMost = isTopMost;
    }

    protected override void OnLoad(EventArgs e)
    {
      base.OnLoad(e);
      lblMsg.Text += maxLevel.ToString();
    }

    private void miOk_Click(object sender, EventArgs e)
    {
      isOk = true;
      Close();
    }

    private void miCancel_Click(object sender, EventArgs e)
    {
      isOk = false;
      Close();
    }
  }
}